# coding: utf-8

"""
    Aladdin User Group Member

    API contains operations on Aladdin User Group Member resource. Note: This is not intended to be used for Authorization.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_platform.agraph.platform.access.user_group.v1.UserGroupMemberAPI.models.v1_user_group_member import V1UserGroupMember

class V1ListUserGroupMembersResponse(BaseModel):
    """
    The response message for UserGroupMemberAPI.ListUserGroupMembers.
    """
    user_group_members: Optional[conlist(V1UserGroupMember)] = Field(None, alias="userGroupMembers", description="The members to be returned.")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="A token, which can be sent as 'page_token' to retrieve the next page. If this field is omitted, there are no subsequent pages.")
    __properties = ["userGroupMembers", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ListUserGroupMembersResponse:
        """Create an instance of V1ListUserGroupMembersResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in user_group_members (list)
        _items = []
        if self.user_group_members:
            for _item in self.user_group_members:
                if _item:
                    _items.append(_item.to_dict())
            _dict['userGroupMembers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ListUserGroupMembersResponse:
        """Create an instance of V1ListUserGroupMembersResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ListUserGroupMembersResponse.parse_obj(obj)

        _obj = V1ListUserGroupMembersResponse.parse_obj({
            "user_group_members": [V1UserGroupMember.from_dict(_item) for _item in obj.get("userGroupMembers")] if obj.get("userGroupMembers") is not None else None,
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

