# coding: utf-8

"""
    Adc Dataset

    Manages Datasets in Aladdin Data Cloud (ADC). Used by Studio's ADC Admin Center.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_platform.agraph.platform.studio.adc.adc_dataset.v1.AdcDatasetAPI.models.v1_schema_id import V1SchemaId

class V1RefreshAdcDatasetsRequest(BaseModel):
    """
    V1RefreshAdcDatasetsRequest
    """
    schema_id: Optional[V1SchemaId] = Field(None, alias="schemaId")
    dataset_names: Optional[conlist(StrictStr)] = Field(None, alias="datasetNames")
    __properties = ["schemaId", "datasetNames"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1RefreshAdcDatasetsRequest:
        """Create an instance of V1RefreshAdcDatasetsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of schema_id
        if self.schema_id:
            _dict['schemaId'] = self.schema_id.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1RefreshAdcDatasetsRequest:
        """Create an instance of V1RefreshAdcDatasetsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1RefreshAdcDatasetsRequest.parse_obj(obj)

        _obj = V1RefreshAdcDatasetsRequest.parse_obj({
            "schema_id": V1SchemaId.from_dict(obj.get("schemaId")) if obj.get("schemaId") is not None else None,
            "dataset_names": obj.get("datasetNames")
        })
        return _obj

